# LLVM: `bugpoint` tool

### NAME

`bugpoint`

### SYNOPSIS

`bugpoint [options] [input llvm ll/bc files] [LLVM passes] --args <program arguments>...`

### DESCRIPTION

The `bugpoint` tool is a generally useful tool for narrowing down problems in LLVM tools and passes. It can be used to debug three types of failures: optimizer crashes, miscompilations by optimizers, or invalid native code generation. It aims to reduce testcases to something useful. For example, if `gccas` crashes while optimizing a file, it will identify the optimization (or combination of optimizations) that causes the crash, and reduce the file down to a small example which triggers the crash.

`bugpoint` has been designed to be a useful tool without requiring any hooks into the LLVM intrastructure at all. It works with any and all LLVM passes and code generators, and does not need to "know" how they work. Because of this, it may appear to do a lot of stupid things or miss obvious simplifications. Remember, however, that computer time is much cheaper than programmer time, so if it takes a long time to reduce a testcase it is still worth it. :)

#### Automatic Mode Selection

`bugpoint` reads the specified list of `.bc` or `.ll` files specified on the command-line and links them together. If any LLVM passes are specified on the command line, it runs these passes on the resultant module. If any of the passes crash, or if they produce a malformed LLVM module, `bugpoint` enters crash debugging mode.

Otherwise, if the `-output` option was not specified, `bugpoint` runs the initial program with the C backend (which is assumed to generate good code) to generate a reference output. Once `bugpoint` has a reference output to match, it tries executing the original program with the selected code generator. If the resultant output is different than the reference output, it exters code generator debugging mode.

Otherwise, `bugpoint` runs the LLVM program after all of the LLVM passes have been applied to it. If the executed program matches the reference output, there is no problem `bugpoint` can debug. Otherwise, it enters miscompilation debugging mode.

#### Crash debugging mode

If an optimizer crashes, `bugpoint` will try a variety of techniques to narrow down the list of passes and the code to a more manageable amount. First, `bugpoint` figures out which combination of passes trigger the bug. This is useful when debugging a problem exposed by `gccas` for example, because it has over 30 optimization it runs.

Next, `bugpoint` tries removing functions from the module, to reduce the size of the testcase to a reasonable amount. Usually it is able to get it down to a single function for intraprocedural optimizations. Once the number of functions has been reduced, it attempts to delete various edges in the control flow graph, to reduce the size of the function as much as possible. Finally, `bugpoint` deletes any individual LLVM instructions whose absense does not eliminate the failure. At the end, `bugpoint` should tell you what passes crash, give you a bytecode file, and give you instructions on how to reproduce the failure with `opt` or `analyze`.

#### Code generator debugging mode

The code generator debugger attempts to narrow down the amount of code that is being miscompiled by the selected code generator. To do this, it takes the LLVM program and partitions it into two pieces: one piece which it compiles with the C backend (into a shared object), and one piece which it runs with either the JIT or the static LLC compiler. It uses several techniques to reduce the amount of code pushed through the LLVM code generator, to reduce the potential scope of the problem. After it is finished, it emits two bytecode files (the "test" [to be compiled with the code generator] and "safe" [to be compiled with the C backend] modules), and instructions for reproducing the problem. This module assume the C backend produces good code.

If you are using this mode and get an error message that says "Non-instruction is using an external function!", try using the `-run-llc` option instead of the `-run-jit` option. This is due to an unimplemented feature in the code generator debugging mode.

#### Miscompilation debugging mode

The miscompilation debugging mode works similarly to the code generator debugging mode. It works by splitting the program into two pieces, running the optimizations specified on one piece, relinking the program, then executing it. It attempts to narrow down the list of passes to the one (or few) which are causing the miscompilation, then reduce the portion of the program which is being miscompiled. This module assumes that the selected code generator is working properly.

#### Advice for using `bugpoint`

`bugpoint` can be a remarkably useful tool, but it sometimes works in non-obvious ways. Here are some hints and tips:

1. In code generator and miscompilation debugging modes, `bugpoint` only works with programs that have deterministic output. Thus, if the program outputs the date, time, or any other "random" data, it should be masked out.
2. In code generator and miscompilation debugging modes, debugging will go faster if you manually modify the program or its inputs to reduce the runtime, but still exhibit the problem.
3. `bugpoint` is extremely useful when working on a new optimization: it helps track down regressions quickly. To avoid having to relink `bugpoint` every time you change your optization however, have `bugpoint` dynamically load your optimization with the `-load` option.
4. `bugpoint` can generate a lot of output and run for a long period of time. It is often useful to capture the output of the program to file. For example:
   `bugpoint ..... |& tee bugpoint.log`

### OPTIONS

- `-additional-so <library.so>`
  Use this option to specify .so files which must be loaded by the program when it is run. This is useful if you are debugging programs which depend on non-LLVM libraries (such as the X or curses libraries) to run.

- `-args <arguments>`
  All arguments specified after `-args` are passed into the executed program when the program must be executed. Note that if the program takes an argument which starts with a '-', you should use:

  `bugpoint .... -args -- (the arguments here)`

  The "`--`" right after the `-args` option tells `bugpoint` to consider any options starting with `-` to be part of the `-args` option, not as options to `bugpoint` itself.

- `-disable-(adce,dce,final-cleanup,simplifycfg)`
  `bugpoint` uses several passes internally for cleanup routines to reduce the size of the program. If you're trying to find a bug in one of these passes, `bugpoint` may crash. These options tell `bugpoint` not use the specified passes.

- `-help`
  Print a summary of command line options.

- `-input <filename>`
  Specify the contents of <stdin> when the program must be executed.

- `-load <plugin.so>`
  Load the dynamic object plugin.so. This object should register new optimization passes. Once loaded, the object will add new command line options to enable various optimizations. To see the new complete list of optimizations, use the -help and -load options together:

  `opt -load <plugin.so> -help`

- `-output <filename>`
  Specify a reference output for the <stdout> file stream.

- `-run-(int|jit|llc|cbe)`
  Specify which code generator `bugpoint` should use to run the program. You may choose the interpreter, the JIT compiler, the static native code compiler, or the C backend.

### EXIT STATUS

If `bugpoint` succeeds in finding a problem, it will exit with 0. Otherwise, if an error occurs, it will exit with a non-zero value.

### SEE ALSO

`opt`, `analyze`

Maintained by the LLVM Team.